org.cpsolver.ifs.solution

## Class GeneralSolutionComparator<V extends Variable<V,T>,T extends Value<V,T>>

- java.lang.Object
- - org.cpsolver.ifs.solution.GeneralSolutionComparator<V,T>

- Type Parameters:
    `V` - Variable
    `T` - Value
  All Implemented Interfaces:
    SolutionComparator<V,T>
  Direct Known Subclasses:
    TimetableComparator

      public class GeneralSolutionComparator<V extends Variable<V,T>,T extends Value<V,T>>
      extends Object
      implements SolutionComparator<V,T>

  General implementation of solution comparator.
  The solution is better than the best ever found solution when it has more variables assigned. In the case, when both solutions have the same number of assigned variables, the better solution is the one with smaller total value, i.e., the sum of `Value.toDouble(Assignment)` over all assigned variables.
  Version:
    IFS 1.3 (Iterative Forward Search)
    Copyright (C) 2006 - 2014 Tomáš Müller
    muller@unitime.org
    http://muller.unitime.org
    This library is free software; you can redistribute it and/or modify it under the terms of the GNU Lesser General Public License as published by the Free Software Foundation; either version 3 of the License, or (at your option) any later version.
    This library is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public License for more details.
    You should have received a copy of the GNU Lesser General Public License along with this library; if not see http://www.gnu.org/licenses/.
  Author:
    Tomáš Müller
  See Also:
    `Solution`, `Solver`

- - ### Constructor Summary

    Constructors
    Constructor and Description
    `GeneralSolutionComparator()`
    `GeneralSolutionComparator(DataProperties properties)` No parameters are used so far.

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `boolean` | `isBetterThanBestSolution(Solution<V,T> currentSolution)` Compares two solutions.

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Constructor Detail

    - #### GeneralSolutionComparator

          public GeneralSolutionComparator()

    - #### GeneralSolutionComparator

          public GeneralSolutionComparator(DataProperties properties)

      No parameters are used so far.
      Parameters:
        `properties` - solver configuration

  - ### Method Detail

    - #### isBetterThanBestSolution

          public boolean isBetterThanBestSolution(Solution<V,T> currentSolution)

      Description copied from interface: `SolutionComparator`
      Compares two solutions. Returns true if the given solution is better than its best ever found solution (see `Solution.saveBest()` and `Solution.restoreBest()`).
      Specified by:
        `isBetterThanBestSolution` in interface `SolutionComparator<V extends Variable<V,T>,T extends Value<V,T>>`
      Parameters:
        `currentSolution` - given solution
      Returns:
        true if the given solution is better than the best ever found solution